package com.agiledeveloper;

import java.lang.reflect.Method;

public class Example
{
    public static void report(Class theClass)
    {
        if (theClass.isAnnotationPresent(AuthorInfo.class))
        {
            AuthorInfo authInfo = (AuthorInfo) theClass.getAnnotation(AuthorInfo.class);

            System.out.printf("name = %s, email = %s, comment = %s\n",
                    authInfo.name(), authInfo.email(), authInfo.comment());

            try
            {
                Method fooMethod = theClass.getMethod("foo", null);
                if (fooMethod.isAnnotationPresent(AuthorInfo.class))
                {
                    AuthorInfo methodAuthInfo = (AuthorInfo) fooMethod.getAnnotation(AuthorInfo.class);
                    System.out.printf("name = %s, email = %s, comment = %s\n",
                            methodAuthInfo.name(), methodAuthInfo.email(), methodAuthInfo.comment());
                }
            }
            catch (NoSuchMethodException e)
            {
                e.printStackTrace();
            }

        }
        else
        {
            System.out.println("SomeClass does not have AuthorInfo");
        }
    }

    public static void main(String[] args)
    {
        // We will programatically query for annotation

        // Try commenting out the @Inherited in AuthorInfo.

        report(new SomeClass().getClass());
        report(new SomeClass2().getClass());

        report(SomeClass.class);
        report(SomeClass2.class);
    }
}