package com.agiledeveloper;

import java.util.EnumSet;

enum CoffeeSize {SMALL, MEDIUM, LARGE};

enum DaysOfWeek {SUNDAY, MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY};

enum ActivityOfWeek
{
    SUNDAY
    {
        public void action()
        {
            System.out.println("Relax");
        }
    },

    MONDAY
    {
        public void action()
        {
            System.out.println("Watch Football");
        }
    },

    TUESDAY
    {
        public void action()
        {
            System.out.println("Swimming");
        }
    },

    WEDNESDAY
    {
        public void action()
        {
            System.out.println("Music");
        }
    },

    THURSDAY
    {
        public void action()
        {
            System.out.println("Tennis");
        }
    },

    FRIDAY
    {
        public void action()
        {
            System.out.println("Dinner");
        }
    },

    SATURDAY
    {
        public void action()
        {
            System.out.println("Movie");
        }
    };

    public abstract void action();
}

enum Methodologies
{
    Evo(5),
    XP(21),
    Scrum(30);

    private int daysInIteration;
    Methodologies(int days)
    {
        daysInIteration = days;
    }

    public void iterationDetails()
    {
        System.out.println(this + " recommends " + daysInIteration + " days for iteration");
    }
}

public class Example
{
    public static void orderCoffee(CoffeeSize size)
    {
        System.out.println("Coffee order received for size " + size);
    }

    public static void main(String[] args)
    {
        orderCoffee(CoffeeSize.SMALL);
        orderCoffee(CoffeeSize.LARGE);
        orderCoffee(CoffeeSize.MEDIUM);

        System.out.println("Available size are:");
        for(CoffeeSize size : CoffeeSize.values())
        {
            System.out.println(size);
        }

        System.out.print("Work days are: ");
        for(DaysOfWeek day : EnumSet.range(DaysOfWeek.MONDAY, DaysOfWeek.FRIDAY))
        {
            System.out.print(day + " ");
        }

        System.out.println("");
        System.out.println("Activity during the week");
        for(ActivityOfWeek day : ActivityOfWeek.values())
        {
            System.out.print(day + " - ");
            day.action();
        }

        for(Methodologies m : Methodologies.values())
        {
            m.iterationDetails();
        }
    }
}
